#include <iostream>
#include "Tree.h"

int main(int argc, char ** argv)
{
  CNode *n1 = new CNode(7);

  CTree *tr = new CTree(n1);

  CNode *n2 = new CNode(6);
  tr->addSon(n1, n2);

  CNode *n3 = new CNode(5);
  tr->addSon(n1, n3);

  CNode *n4 = new CNode(1);
  tr->addSon(n2, n4);

  CNode *n5 = new CNode(2);
  tr->addSon(n2, n5);

  CNode *n6 = new CNode(3);
  tr->addSon(n3, n6);

  CNode *x1 = new CNode(4);
  tr->addSon(n3,x1);
  cout << "Tree\n";
  tr->printTree();
  cout << "Nb Nodes: " << tr->NbNodesGet() << "\n";
  tr->LCApreprocess();
  /**/
  cout << "\nTesting all lca nodes (" << tr->NbNodesGet() << ")\n";
  for (int i; i <tr->NbNodesGet(); i++) {
    for (int j=i; j< tr->NbNodesGet(); j++) {
      CNode *xx, *yy;
      xx = tr->NodesGet(i);
      yy = tr->NodesGet(j);
      if (tr->LCAGet(xx,yy) != tr->LCAGetSlow(xx,yy)) {
	cout << "Error node " << i << "," << j << "\n";
      }
    }
  }
  cout << "------> Testing done\n";

  cout << "Fast: Ancestor(1,4) = 7 - " << tr->LCAGet(x1,n4)->data << " " << x1->data << "-" << n4->data << "\n";
  cout << "Slow: Ancestor(1,4) = 7 - " << tr->LCAGetSlow(x1,n4)->data << " " << x1->data << "-" << n4->data << "\n";
  
  /**/
  cout << "Fast: Ancestor(1,5) = " << tr->LCAGet(n4, n3)->data << "\n"; 
  cout << "Fast: Ancestor(1,5) = " << tr->NodesGet(tr->LCAGet(n4->Represent, n3->Represent))->data << "\n"; 
  cout << "Slow: Ancestor(1,5) = " << tr->LCAGetSlow(n4, n3)->data << "\n"; 

  cout << "Delete 2\n";
  tr->deleteNode(n2);
  tr->printTree();
  cout << "Nb Nodes: " << tr->NbNodesGet() << "\n";

  cout << "add a root\n";
  CNode *n7 = new CNode(7);
  tr->addSon(n7, tr->RootGet());
  tr->printTree();
  cout << "Nb Nodes: " << tr->NbNodesGet() << "\n";

  cout << "Swap the root and its son\n";
  tr->swap(tr->RootGet(), *tr->RootGet()->sons.begin());
  tr->printTree();

  /**/
  //Clean up
  cout << "Cleaning up\n";
  tr->clearMemory();
  
  cout << "Testing 10,5: " << tr->testing(10, 5) << " errors\n";
  cout << "It was tested with " << tr->NbNodesGet() << " nodes\n";
  //tr->printTree();
  tr->clearMemory();
  cout << "end\n";
  return 0;
}
