#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "graphaux.h"
#include "graphes.h"

#define ECHELLE 25.7   // en metres
#define VITESSE 10.0   // en m/s (= 36km/h)
#define arrondi(z) ((z-(double)((int)z))<=0.5?((int)z):((int)z+1))

double dist(double x1, double y1, double x2, double y2)
{
  double dx = x2 - x1;
  double dy = y2 - y1;
  return sqrt(dx * dx + dy * dy);
}

void main(int argc, char **argv)
{
  graphe *g, *gv;
  int n, m;     /* nombre d'arcs, nombre de sommets */
  int i, j;
  pcell p;
  double v;

  if (argc != 3)
  {
    fprintf(stderr, "usage: %s gr_coord gr_value\n", argv[0]);
    exit(0);
  }

  g = ReadGraphe(argv[1]);             /* lit le graphe a partir du fichier */
  n = g->nsom;
  m = g->narc;
  gv = InitGraphe(n, m);

  for (i = 0; i < n; i++)
  {
    for (p = g->gamma[i]; p != NULL; p = p->next)
    {
      j = p->som;
      v = dist(g->x[i], g->y[i], g->x[j], g->y[j]) * ECHELLE / VITESSE;
      AjouteArcValue(gv, i, j, arrondi(v));
    }
  }

  WriteGraphe(gv, argv[2], 1, 0, 0);

  TermineGraphe(g);
  TermineGraphe(gv);

} /* main() */
