#include <stdlib.h>
#include <stdio.h>
#include "graphaux.h"
#include "graphes.h"

#define USAGE "idem exo122, mais avec la fonction symetrique (algo lineaire)"

/* ====================================================================== */
graphe * symetrique(graphe * g)
/* ====================================================================== */
{
  graphe *g_1;
  int nsom, narc, al_arcs, k, i, j;
  pcell p;

  nsom = g->nsom;
  narc = g->narc;
  g_1 = InitGraphe(nsom, narc);
  for (i = 0; i < nsom; i++) /* pour tout i sommet de g */
  {
    for (p = g->gamma[i]; p != NULL; p = p->next)
    { /* pour tout j successeur de i */
      j = p->som;
      AjouteArc(g_1, j, i);
    }
  }

  return g_1;
} /* symetrique() */

/* ====================================================================== */
int main(int argc, char **argv)
/* ====================================================================== */
{
  graphe *g, *g_1;
  int na, ns;     /* nombre d'arcs, nombre de sommets */
  chrono Chrono1; /* pour la mesure du temps */
  int temps;      /* idem */

  if (argc != 3)
  {
    fprintf(stderr, "usage: %s <nombre sommets> <nombre arcs>\n%s\n", argv[0], USAGE);
    exit(0);
  }

  ns = atoi(argv[1]);
  na = atoi(argv[2]);

  g = GrapheAleatoire(ns, na);   /* genere un graphe aleatoire antisymetrique sans boucle */
  start_chrono(&Chrono1);        /* top chrono : debut du traitement */
  g_1 = symetrique(g);           /* traitement : calcule le symetrique de g */
  temps = read_chrono(&Chrono1); /* top chrono : fin du traitement */

  TermineGraphe(g);
  TermineGraphe(g_1);

  printf("temps de traitement : %g secondes\n", ((double)temps)/1e6);

  return 0;
} /* main() */
