#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "graphaux.h"
#include "graphes.h"

int main(int argc, char **argv)
{
  graphe *g;    // graphe  
  int na, ns;   // nombre d'arcs, nombre de sommets
  FILE *fd;     // descripteur de fichier
  double x, y;  // point
  int i;

  if (argc != 2)
  {
    fprintf(stderr, "usage: %s listepoints\n", argv[0]);
    exit(0);
  }

  fd = fopen(argv[1], "r"); // ouverture en lecture du fichier dont le nom est dans argv[1]
  if (!fd)
  {
    fprintf(stderr, "cannot open file: %s\n", argv[1]);
    exit(0);
  }

  fscanf(fd, "%d", &ns);    // lit le nombre de points (type "int") dans le fichier
  na = (ns * (ns - 1)) / 2; // calcule le nombre max d'arcs
  g = InitGraphe(ns, na);   // alloue la structure graphe en memoire

  for (i = 0; i < ns; i++)
  {
    fscanf(fd, "%lf %lf", &x, &y); // lit les 2 coord. d'1 point dans le fichier
    g->x[i] = x; g->y[i] = y;      // range les coord. dans les champs x et y de g
  }

  fclose(fd);               // fermeture fichier

  PSGraphe(g, "graph.ps", 4, 0, 5); // genere une figure en PostScript

  TermineGraphe(g);

} /* main() */
