#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "graphaux.h"
#include "graphes.h"

double DistanceEuclidienne(double x1, double y1, double x2, double y2)
{
  double dx = x2 - x1;
  double dy = y2 - y1;
  return sqrt(dx * dx + dy * dy);
}

int main(int argc, char **argv)
{
  graphe *g;
  int na, ns;     /* nombre d'arcs, nombre de sommets */
  chrono Chrono1; /* pour la mesure du temps */
  int temps;      /* idem */
  FILE *fd;
  int i, j, narc;
  double d, t;

  if (argc != 3)
  {
    fprintf(stderr, "usage: %s listepoints d\n", argv[0]);
    exit(0);
  }
  d = atof(argv[2]);
  fd = fopen(argv[1], "r");
  if (!fd)
  {
    fprintf(stderr, "cannot open file: %s\n", argv[1]);
    exit(0);
  }
  fscanf(fd, "%d", &ns);
  na = (ns * (ns - 1)) / 2;
  g = InitGraphe(ns, na);
  for (i = 0; i < ns; i++)
    fscanf(fd, "%lf %lf", &(g->x[i]), &(g->y[i]));
  fclose(fd);

  // construit le graphe des distances sur les sommets de g (antisymetrique et sans boucle)
  narc = 0;
  for (i = 0; i < ns; i++)
    for (j = i+1; j < ns; j++)
    { 
      t = DistanceEuclidienne(g->x[i], g->y[i], g->x[j], g->y[j]);
      if (t <= d)
      {
        AjouteArc(g, i, j);
        g->tete[narc] = i;
        g->queue[narc] = j;
        g->v_arcs[narc] = (long)t;
        narc++;
      }
    } // for i, j

  // genere une figure en PostScript
  PSGraphe(g, "graph.ps", 4, 0, 5);

  TermineGraphe(g);

  return 0;
} /* main() */
