#define PINK

#include <stdlib.h>
#include <stdio.h>
#include <mccodimage.h>
#include <mcimage.h>
#include "graphaux.h"
#include "graphes.h"

/* =============================================================== */
int main(int argc, char **argv)
/* =============================================================== */
{
  struct xvimage * image;
  graphe *g;

  if (argc != 3)
  {
    fprintf(stderr, "usage: %s in1.pgm out.graph \n", argv[0]);
    exit(1);
  }

  image = readimage(argv[1]);  
  if (image == NULL)
  {
    fprintf(stderr, "%s: readimage failed\n", argv[0]);
    exit(1);
  }

  g = Image2Graphe(image);

  SaveGraphe(g, argv[argc - 1]); 
  freeimage(image);
  TermineGraphe(g);

  return 0;
} /* main */
